#include <hmg.ch>

FUNCTION DoKR()
	PRIV nTel := 1
			
	USE
	USE VM alias VM NEW
	INDEX ON CurID TO VML01 
	SET INDEX TO VML01
	
	SET SOFTSEEK OFF
	SET DELETED ON
	ZAP
	VM->(DBAppend())
	VM->CurID := 'BEF'
	VM->CurOm := 'FRANK'
	VM->(DBAppend())
	VM->CurID := 'EUR'
	VM->CurOm := 'EURO'
	VM->(DBAppend())
	VM->CurID := 'NLG'
	VM->CurOm := 'GULDEN'
	
	DO WHILE nTel <= 50
		VM->(DBAppend())
		VM->CurID := ALLTRIM(STR(nTel))
		VM->CurOm := 'DESCRIPTION ' + VM->CurID + 'DESCRIPTION ' + VM->CurID + 'DESCRIPTION ' + VM->CurID
		nTel = nTel + 1
	ENDDO
	
	COMMIT
	
	IF ! IsWindowDefined( Win_KR )
		Load Window Win_KR
		Win_KR.Center 
		Win_KR.Activate
	ENDIF
RETURN

FUNCTION OnInit_Win_KR()
	VM->(DBSetorder( "VML01" ))
	VM->(DBGotop())
	Win_KR.KR_Grid_KR.Refresh
	Win_KR.KR_Browse_KR.Refresh
RETURN

FUNCTION KR_Button_Add()
	LOCAL nRecno
	VM->(DBAppend())
	VM->CurID := STR(nTel)
	VM->CurOm := 'DESCRIPTION ' + VM->CurID
	nRecno := VM->(recno())
	Win_KR.KR_Grid_KR.Refresh
	Win_KR.KR_Grid_KR.Setfocus
	Win_KR.KR_Grid_KR.RecNo := nRecno
	Win_KR.KR_Browse_KR.Refresh
	Win_KR.KR_Browse_KR.Setfocus
	Win_KR.KR_Browse_KR.Refresh
	Win_KR.KR_Browse_KR.Value := nRecno
	nTel++
RETURN

FUNCTION KR_Button_Del_Grid()

	// this is redundant, see:
	// Msgdebug( Win_KR.KR_Grid_KR.RecNo )
	// VM->(DBGoto( Win_KR.KR_Grid_KR.RecNo ))
	// Msgdebug( Win_KR.KR_Grid_KR.RecNo )

	// GRID with DataBase works with internal data buffer for Delete, Recall and Append records
	Win_KR.KR_Grid_KR.Delete   // marks the current record for deletion
	Win_KR.KR_Grid_KR.Save     // execute pending operations and update internal buffer, in this case delete record( DBDelete() )

	// DeleteRec()

	Win_KR.KR_Browse_KR.Value := VM->(recno())
	Win_KR.KR_Browse_KR.Refresh

	// Win_KR.KR_Grid_KR.RecNo := VM->(recno())
	// Win_KR.KR_Grid_KR.Refresh

	Win_KR.KR_Grid_KR.Setfocus
RETURN

FUNCTION KR_Button_Del_Browse()
	VM->(DBGoto( Win_KR.KR_Browse_KR.Value ))
	Deleterec()
	Win_KR.KR_Grid_KR.RecNo := VM->(recno())
	Win_KR.KR_Grid_KR.Refresh
	Win_KR.KR_Browse_KR.Value := VM->(recno())
	Win_KR.KR_Browse_KR.Refresh
	Win_KR.KR_Browse_KR.Setfocus
RETURN

FUNCTION DeleteRec()
	VM->(DBDelete())
	VM->(DBSkip())
	IF VM->(EOF())
		VM->(DBGoBottom())
	ENDIF
RETURN

FUNCTION KR_Button_Refresh()
	Win_KR.KR_Grid_KR.Refresh
	Win_KR.KR_Browse_KR.Refresh
RETURN

FUNCTION CloseVM()
	USE
RETURN